##// END OF EJS Templates
0
Unknown -
r673:e8b7ddd1fa04
parent child
Show More
@@ -1,896 +1,896
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = "bullseye" ] ; then
47 if [ $RELEASE = "bullseye" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50
50
51 # Kernel Branch
51 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
53
54 # URLs
54 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
64
65 # Kernel deb packages for 32bit kernel
65 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
70 # Default precompiled 64bit kernel
70 # Default precompiled 64bit kernel
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
76 # Generic
76 # Generic
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81
81
82 # Build directories
82 # Build directories
83 WORKDIR=$(pwd)
83 WORKDIR=$(pwd)
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 BUILDDIR="${BASEDIR}/build"
85 BUILDDIR="${BASEDIR}/build"
86
86
87 # Chroot directories
87 # Chroot directories
88 R="${BUILDDIR}/chroot"
88 R="${BUILDDIR}/chroot"
89 ETC_DIR="${R}/etc"
89 ETC_DIR="${R}/etc"
90 LIB_DIR="${R}/lib"
90 LIB_DIR="${R}/lib"
91 BOOT_DIR="${R}/boot/firmware"
91 BOOT_DIR="${R}/boot/firmware"
92 KERNEL_DIR="${R}/usr/src/linux"
92 KERNEL_DIR="${R}/usr/src/linux"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95
95
96 # Firmware directory: Blank if download from github
96 # Firmware directory: Blank if download from github
97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
98
98
99 # General settings
99 # General settings
100 SET_ARCH=${SET_ARCH:=32}
100 SET_ARCH=${SET_ARCH:=32}
101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
102 PASSWORD=${PASSWORD:=raspberry}
102 PASSWORD=${PASSWORD:=raspberry}
103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
106 EXPANDROOT=${EXPANDROOT:=true}
106 EXPANDROOT=${EXPANDROOT:=true}
107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
108
108
109 # Keyboard settings
109 # Keyboard settings
110 XKB_MODEL=${XKB_MODEL:=""}
110 XKB_MODEL=${XKB_MODEL:=""}
111 XKB_LAYOUT=${XKB_LAYOUT:=""}
111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 XKB_VARIANT=${XKB_VARIANT:=""}
112 XKB_VARIANT=${XKB_VARIANT:=""}
113 XKB_OPTIONS=${XKB_OPTIONS:=""}
113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114
114
115 # Network settings (DHCP)
115 # Network settings (DHCP)
116 ENABLE_DHCP=${ENABLE_DHCP:=true}
116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117
117
118 # Network settings (static)
118 # Network settings (static)
119 NET_ADDRESS=${NET_ADDRESS:=""}
119 NET_ADDRESS=${NET_ADDRESS:=""}
120 NET_GATEWAY=${NET_GATEWAY:=""}
120 NET_GATEWAY=${NET_GATEWAY:=""}
121 NET_DNS_1=${NET_DNS_1:=""}
121 NET_DNS_1=${NET_DNS_1:=""}
122 NET_DNS_2=${NET_DNS_2:=""}
122 NET_DNS_2=${NET_DNS_2:=""}
123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 NET_NTP_1=${NET_NTP_1:=""}
124 NET_NTP_1=${NET_NTP_1:=""}
125 NET_NTP_2=${NET_NTP_2:=""}
125 NET_NTP_2=${NET_NTP_2:=""}
126
126
127 # APT settings
127 # APT settings
128 APT_PROXY=${APT_PROXY:=""}
128 APT_PROXY=${APT_PROXY:=""}
129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
131
131
132 # Feature settings
132 # Feature settings
133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
137 ENABLE_I2C=${ENABLE_I2C:=false}
137 ENABLE_I2C=${ENABLE_I2C:=false}
138 ENABLE_SPI=${ENABLE_SPI:=false}
138 ENABLE_SPI=${ENABLE_SPI:=false}
139 ENABLE_IPV6=${ENABLE_IPV6:=true}
139 ENABLE_IPV6=${ENABLE_IPV6:=true}
140 ENABLE_SSHD=${ENABLE_SSHD:=true}
140 ENABLE_SSHD=${ENABLE_SSHD:=true}
141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
143 ENABLE_SOUND=${ENABLE_SOUND:=true}
143 ENABLE_SOUND=${ENABLE_SOUND:=true}
144 ENABLE_DBUS=${ENABLE_DBUS:=true}
144 ENABLE_DBUS=${ENABLE_DBUS:=true}
145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
147 ENABLE_XORG=${ENABLE_XORG:=false}
147 ENABLE_XORG=${ENABLE_XORG:=false}
148 ENABLE_WM=${ENABLE_WM:=""}
148 ENABLE_WM=${ENABLE_WM:=""}
149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
150 ENABLE_USER=${ENABLE_USER:=true}
150 ENABLE_USER=${ENABLE_USER:=true}
151 USER_NAME=${USER_NAME:="pi"}
151 USER_NAME=${USER_NAME:="pi"}
152 ENABLE_ROOT=${ENABLE_ROOT:=false}
152 ENABLE_ROOT=${ENABLE_ROOT:=false}
153 ENABLE_QEMU=${ENABLE_QEMU:=false}
153 ENABLE_QEMU=${ENABLE_QEMU:=false}
154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
155
155
156 # SSH settings
156 # SSH settings
157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
162
162
163 # Advanced settings
163 # Advanced settings
164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
182 ENABLE_LOGO=${ENABLE_LOGO:=true}
182 ENABLE_LOGO=${ENABLE_LOGO:=true}
183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
185
185
186 # Kernel compilation settings
186 # Kernel compilation settings
187 BUILD_KERNEL=${BUILD_KERNEL:=true}
187 BUILD_KERNEL=${BUILD_KERNEL:=true}
188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
189 KERNEL_THREADS=${KERNEL_THREADS:=1}
189 KERNEL_THREADS=${KERNEL_THREADS:=1}
190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
196 KERNEL_VIRT=${KERNEL_VIRT:=false}
196 KERNEL_VIRT=${KERNEL_VIRT:=false}
197 KERNEL_BPF=${KERNEL_BPF:=false}
197 KERNEL_BPF=${KERNEL_BPF:=false}
198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
200 KERNEL_NF=${KERNEL_NF:=false}
200 KERNEL_NF=${KERNEL_NF:=false}
201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
205
205
206 # Kernel compilation from source directory settings
206 # Kernel compilation from source directory settings
207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
211
211
212 # Reduce disk usage settings
212 # Reduce disk usage settings
213 REDUCE_APT=${REDUCE_APT:=true}
213 REDUCE_APT=${REDUCE_APT:=true}
214 REDUCE_DOC=${REDUCE_DOC:=true}
214 REDUCE_DOC=${REDUCE_DOC:=true}
215 REDUCE_MAN=${REDUCE_MAN:=true}
215 REDUCE_MAN=${REDUCE_MAN:=true}
216 REDUCE_VIM=${REDUCE_VIM:=false}
216 REDUCE_VIM=${REDUCE_VIM:=false}
217 REDUCE_BASH=${REDUCE_BASH:=false}
217 REDUCE_BASH=${REDUCE_BASH:=false}
218 REDUCE_HWDB=${REDUCE_HWDB:=true}
218 REDUCE_HWDB=${REDUCE_HWDB:=true}
219 REDUCE_SSHD=${REDUCE_SSHD:=true}
219 REDUCE_SSHD=${REDUCE_SSHD:=true}
220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
221
221
222 # Encrypted filesystem settings
222 # Encrypted filesystem settings
223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
227 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
227 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
228 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
228 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
229 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
229 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
230 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
230 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
231 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
231 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
232
232
233 # Chroot scripts directory
233 # Chroot scripts directory
234 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
234 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
235
235
236 # Packages required in the chroot build environment
236 # Packages required in the chroot build environment
237 APT_INCLUDES=${APT_INCLUDES:=""}
237 APT_INCLUDES=${APT_INCLUDES:=""}
238 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
238 APT_INCLUDES="${APT_INCLUDES},flex,bison,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
239
239
240 # Packages to exclude from chroot build environment
240 # Packages to exclude from chroot build environment
241 APT_EXCLUDES=${APT_EXCLUDES:=""}
241 APT_EXCLUDES=${APT_EXCLUDES:=""}
242
242
243 # Packages required for bootstrapping
243 # Packages required for bootstrapping
244 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
244 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
245 MISSING_PACKAGES=""
245 MISSING_PACKAGES=""
246
246
247 # Packages installed for c/c++ build environment in chroot (keep empty)
247 # Packages installed for c/c++ build environment in chroot (keep empty)
248 COMPILER_PACKAGES=""
248 COMPILER_PACKAGES=""
249
249
250 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
250 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
251 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
251 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
252 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
252 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
253 APT_PROXY=http://127.0.0.1:3142/
253 APT_PROXY=http://127.0.0.1:3142/
254 fi
254 fi
255
255
256 # Setup architecture specific settings
256 # Setup architecture specific settings
257 if [ -n "$SET_ARCH" ] ; then
257 if [ -n "$SET_ARCH" ] ; then
258 # 64-bit configuration
258 # 64-bit configuration
259 if [ "$SET_ARCH" = 64 ] ; then
259 if [ "$SET_ARCH" = 64 ] ; then
260 # General 64-bit depended settings
260 # General 64-bit depended settings
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
264
264
265 # Raspberry Pi model specific settings
265 # Raspberry Pi model specific settings
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
267 if [ "$RPI_MODEL" != 4 ] ; then
267 if [ "$RPI_MODEL" != 4 ] ; then
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
269 else
269 else
270 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
270 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
271 fi
271 fi
272
272
273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
274 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
274 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
275 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
275 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
276 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
276 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
277 else
277 else
278 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
278 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
279 exit 1
279 exit 1
280 fi
280 fi
281 fi
281 fi
282
282
283 # 32-bit configuration
283 # 32-bit configuration
284 if [ "$SET_ARCH" = 32 ] ; then
284 if [ "$SET_ARCH" = 32 ] ; then
285 # General 32-bit dependend settings
285 # General 32-bit dependend settings
286 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
286 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
287 KERNEL_ARCH=${KERNEL_ARCH:=arm}
287 KERNEL_ARCH=${KERNEL_ARCH:=arm}
288 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
288 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
289
289
290 # Raspberry Pi model specific settings
290 # Raspberry Pi model specific settings
291 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
291 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
292 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
292 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
293 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
293 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
294 RELEASE_ARCH=${RELEASE_ARCH:=armel}
294 RELEASE_ARCH=${RELEASE_ARCH:=armel}
295 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
295 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
296 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
296 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
297 fi
297 fi
298
298
299 # Raspberry Pi model specific settings
299 # Raspberry Pi model specific settings
300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
301 if [ "$RPI_MODEL" != 4 ] ; then
301 if [ "$RPI_MODEL" != 4 ] ; then
302 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
302 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
303 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
303 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
304 else
304 else
305 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
305 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
306 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
306 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
307 fi
307 fi
308
308
309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
310 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
310 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
311
311
312 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
312 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
313 fi
313 fi
314 fi
314 fi
315 # SET_ARCH not set
315 # SET_ARCH not set
316 else
316 else
317 echo "error: Please set '32' or '64' as value for SET_ARCH"
317 echo "error: Please set '32' or '64' as value for SET_ARCH"
318 exit 1
318 exit 1
319 fi
319 fi
320 # Device specific configuration and U-Boot configuration
320 # Device specific configuration and U-Boot configuration
321 case "$RPI_MODEL" in
321 case "$RPI_MODEL" in
322 0)
322 0)
323 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
323 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
325 ;;
325 ;;
326 1)
326 1)
327 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
327 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
329 ;;
329 ;;
330 1P)
330 1P)
331 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
331 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
333 ;;
333 ;;
334 2)
334 2)
335 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
335 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
336 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
336 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
337 ;;
337 ;;
338 3)
338 3)
339 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
339 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
340 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
340 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
341 ;;
341 ;;
342 3P)
342 3P)
343 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
343 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
344 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
344 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
345 ;;
345 ;;
346 4)
346 4)
347 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
347 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
348 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
348 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
349 ;;
349 ;;
350 *)
350 *)
351 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
351 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
352 exit 1
352 exit 1
353 ;;
353 ;;
354 esac
354 esac
355
355
356 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
356 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
357 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
357 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
358 # Include bluetooth packages on supported boards
358 # Include bluetooth packages on supported boards
359 if [ "$ENABLE_BLUETOOTH" = true ] ; then
359 if [ "$ENABLE_BLUETOOTH" = true ] ; then
360 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
360 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
361 fi
361 fi
362 if [ "$ENABLE_WIRELESS" = true ] ; then
362 if [ "$ENABLE_WIRELESS" = true ] ; then
363 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
363 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
364 fi
364 fi
365 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
365 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
366 # Check if the internal wireless interface is not supported by the RPi model
366 # Check if the internal wireless interface is not supported by the RPi model
367 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
367 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
368 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
368 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
369 exit 1
369 exit 1
370 fi
370 fi
371 fi
371 fi
372
372
373 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
373 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
374 echo "error: You have to compile kernel sources, if you want to enable nexmon"
374 echo "error: You have to compile kernel sources, if you want to enable nexmon"
375 exit 1
375 exit 1
376 fi
376 fi
377
377
378 # Prepare date string for default image file name
378 # Prepare date string for default image file name
379 DATE="$(date +%Y-%m-%d)"
379 DATE="$(date +%Y-%m-%d)"
380 if [ -z "$KERNEL_BRANCH" ] ; then
380 if [ -z "$KERNEL_BRANCH" ] ; then
381 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
381 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
382 else
382 else
383 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
383 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
384 fi
384 fi
385
385
386 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
386 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
387 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
387 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
388 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
388 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
389 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
389 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
390 exit 1
390 exit 1
391 fi
391 fi
392 fi
392 fi
393
393
394 # Add cmake to compile videocore sources
394 # Add cmake to compile videocore sources
395 if [ "$ENABLE_VIDEOCORE" = true ] ; then
395 if [ "$ENABLE_VIDEOCORE" = true ] ; then
396 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
396 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
397 fi
397 fi
398
398
399 # Add deps for nexmon
399 # Add deps for nexmon
400 if [ "$ENABLE_NEXMON" = true ] ; then
400 if [ "$ENABLE_NEXMON" = true ] ; then
401 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
401 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
402 fi
402 fi
403
403
404 # Add libncurses5 to enable kernel menuconfig
404 # Add libncurses5 to enable kernel menuconfig
405 if [ "$KERNEL_MENUCONFIG" = true ] ; then
405 if [ "$KERNEL_MENUCONFIG" = true ] ; then
406 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
406 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
407 fi
407 fi
408
408
409 # Add ccache compiler cache for (faster) kernel cross (re)compilation
409 # Add ccache compiler cache for (faster) kernel cross (re)compilation
410 if [ "$KERNEL_CCACHE" = true ] ; then
410 if [ "$KERNEL_CCACHE" = true ] ; then
411 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
411 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
412 fi
412 fi
413
413
414 # Add cryptsetup package to enable filesystem encryption
414 # Add cryptsetup package to enable filesystem encryption
415 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
415 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
416 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
417 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
417 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
418
418
419 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
419 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
420 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
420 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
421 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
421 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
422 fi
422 fi
423
423
424 if [ -z "$CRYPTFS_PASSWORD" ] ; then
424 if [ -z "$CRYPTFS_PASSWORD" ] ; then
425 echo "error: no password defined (CRYPTFS_PASSWORD)!"
425 echo "error: no password defined (CRYPTFS_PASSWORD)!"
426 exit 1
426 exit 1
427 fi
427 fi
428 ENABLE_INITRAMFS=true
428 ENABLE_INITRAMFS=true
429 fi
429 fi
430
430
431 # Add initramfs generation tools
431 # Add initramfs generation tools
432 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
432 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
433 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
433 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
434 fi
434 fi
435
435
436 # Add device-tree-compiler required for building the U-Boot bootloader
436 # Add device-tree-compiler required for building the U-Boot bootloader
437 if [ "$ENABLE_UBOOT" = true ] ; then
437 if [ "$ENABLE_UBOOT" = true ] ; then
438 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
438 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
439 fi
439 fi
440
440
441 if [ "$ENABLE_USBBOOT" = true ] ; then
441 if [ "$ENABLE_USBBOOT" = true ] ; then
442 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
442 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
443 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
443 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
444 exit 1
444 exit 1
445 fi
445 fi
446 fi
446 fi
447
447
448 # Check if root SSH (v2) public key file exists
448 # Check if root SSH (v2) public key file exists
449 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
449 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
450 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
450 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
451 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
451 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
452 exit 1
452 exit 1
453 fi
453 fi
454 fi
454 fi
455
455
456 # Check if $USER_NAME SSH (v2) public key file exists
456 # Check if $USER_NAME SSH (v2) public key file exists
457 if [ -n "$SSH_USER_PUB_KEY" ] ; then
457 if [ -n "$SSH_USER_PUB_KEY" ] ; then
458 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
458 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
459 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
459 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
460 exit 1
460 exit 1
461 fi
461 fi
462 fi
462 fi
463
463
464 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
464 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
465 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
465 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
466 exit 1
466 exit 1
467 fi
467 fi
468
468
469 # Check if all required packages are installed on the build system
469 # Check if all required packages are installed on the build system
470 for package in $REQUIRED_PACKAGES ; do
470 for package in $REQUIRED_PACKAGES ; do
471 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
471 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
472 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
472 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
473 fi
473 fi
474 done
474 done
475
475
476 # If there are missing packages ask confirmation for install, or exit
476 # If there are missing packages ask confirmation for install, or exit
477 if [ -n "$MISSING_PACKAGES" ] ; then
477 if [ -n "$MISSING_PACKAGES" ] ; then
478 echo "the following packages needed by this script are not installed:"
478 echo "the following packages needed by this script are not installed:"
479 echo "$MISSING_PACKAGES"
479 echo "$MISSING_PACKAGES"
480
480
481 printf "\ndo you want to install the missing packages right now? [y/n] "
481 printf "\ndo you want to install the missing packages right now? [y/n] "
482 read -r confirm
482 read -r confirm
483 [ "$confirm" != "y" ] && exit 1
483 [ "$confirm" != "y" ] && exit 1
484
484
485 # Make sure all missing required packages are installed
485 # Make sure all missing required packages are installed
486 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
486 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
487 fi
487 fi
488
488
489 # Check if ./bootstrap.d directory exists
489 # Check if ./bootstrap.d directory exists
490 if [ ! -d "./bootstrap.d/" ] ; then
490 if [ ! -d "./bootstrap.d/" ] ; then
491 echo "error: './bootstrap.d' required directory not found!"
491 echo "error: './bootstrap.d' required directory not found!"
492 exit 1
492 exit 1
493 fi
493 fi
494
494
495 # Check if ./files directory exists
495 # Check if ./files directory exists
496 if [ ! -d "./files/" ] ; then
496 if [ ! -d "./files/" ] ; then
497 echo "error: './files' required directory not found!"
497 echo "error: './files' required directory not found!"
498 exit 1
498 exit 1
499 fi
499 fi
500
500
501 # Check if specified KERNELSRC_DIR directory exists
501 # Check if specified KERNELSRC_DIR directory exists
502 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
502 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
503 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
503 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
504 exit 1
504 exit 1
505 fi
505 fi
506
506
507 # Check if specified UBOOTSRC_DIR directory exists
507 # Check if specified UBOOTSRC_DIR directory exists
508 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
508 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
509 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
509 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
510 exit 1
510 exit 1
511 fi
511 fi
512
512
513 # Check if specified VIDEOCORESRC_DIR directory exists
513 # Check if specified VIDEOCORESRC_DIR directory exists
514 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
514 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
515 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
515 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
516 exit 1
516 exit 1
517 fi
517 fi
518
518
519 # Check if specified FBTURBOSRC_DIR directory exists
519 # Check if specified FBTURBOSRC_DIR directory exists
520 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
520 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
521 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
521 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
522 exit 1
522 exit 1
523 fi
523 fi
524
524
525 # Check if specified NEXMONSRC_DIR directory exists
525 # Check if specified NEXMONSRC_DIR directory exists
526 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
526 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
527 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
527 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
528 exit 1
528 exit 1
529 fi
529 fi
530
530
531 # Check if specified CHROOT_SCRIPTS directory exists
531 # Check if specified CHROOT_SCRIPTS directory exists
532 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
532 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
533 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
533 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
534 exit 1
534 exit 1
535 fi
535 fi
536
536
537 # Check if specified device mapping already exists (will be used by cryptsetup)
537 # Check if specified device mapping already exists (will be used by cryptsetup)
538 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
538 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
539 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
539 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
540 exit 1
540 exit 1
541 fi
541 fi
542
542
543 # Don't clobber an old build
543 # Don't clobber an old build
544 if [ -e "$BUILDDIR" ] ; then
544 if [ -e "$BUILDDIR" ] ; then
545 echo "error: directory ${BUILDDIR} already exists, not proceeding"
545 echo "error: directory ${BUILDDIR} already exists, not proceeding"
546 exit 1
546 exit 1
547 fi
547 fi
548
548
549 # Setup chroot directory
549 # Setup chroot directory
550 mkdir -p "${R}"
550 mkdir -p "${R}"
551
551
552 # Check if build directory has enough of free disk space >512MB
552 # Check if build directory has enough of free disk space >512MB
553 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
553 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
554 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
554 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
555 exit 1
555 exit 1
556 fi
556 fi
557
557
558 set -x
558 set -x
559
559
560 # Call "cleanup" function on various signals and errors
560 # Call "cleanup" function on various signals and errors
561 trap cleanup 0 1 2 3 6
561 trap cleanup 0 1 2 3 6
562
562
563 # Add required packages for the minbase installation
563 # Add required packages for the minbase installation
564 if [ "$ENABLE_MINBASE" = true ] ; then
564 if [ "$ENABLE_MINBASE" = true ] ; then
565 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
565 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
566 fi
566 fi
567
567
568 # Add parted package, required to get partprobe utility
568 # Add parted package, required to get partprobe utility
569 if [ "$EXPANDROOT" = true ] ; then
569 if [ "$EXPANDROOT" = true ] ; then
570 APT_INCLUDES="${APT_INCLUDES},parted"
570 APT_INCLUDES="${APT_INCLUDES},parted"
571 fi
571 fi
572
572
573 # Add dphys-swapfile package, required to enable swap
573 # Add dphys-swapfile package, required to enable swap
574 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
574 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
575 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
575 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
576 fi
576 fi
577
577
578 # Add dbus package, recommended if using systemd
578 # Add dbus package, recommended if using systemd
579 if [ "$ENABLE_DBUS" = true ] ; then
579 if [ "$ENABLE_DBUS" = true ] ; then
580 APT_INCLUDES="${APT_INCLUDES},dbus"
580 APT_INCLUDES="${APT_INCLUDES},dbus"
581 fi
581 fi
582
582
583 # Add iptables IPv4/IPv6 package
583 # Add iptables IPv4/IPv6 package
584 if [ "$ENABLE_IPTABLES" = true ] ; then
584 if [ "$ENABLE_IPTABLES" = true ] ; then
585 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
585 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
586 fi
586 fi
587 # Add apparmor for KERNEL_SECURITY
587 # Add apparmor for KERNEL_SECURITY
588 if [ "$KERNEL_SECURITY" = true ] ; then
588 if [ "$KERNEL_SECURITY" = true ] ; then
589 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
589 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
590 fi
590 fi
591
591
592 # Add openssh server package
592 # Add openssh server package
593 if [ "$ENABLE_SSHD" = true ] ; then
593 if [ "$ENABLE_SSHD" = true ] ; then
594 APT_INCLUDES="${APT_INCLUDES},openssh-server"
594 APT_INCLUDES="${APT_INCLUDES},openssh-server"
595 fi
595 fi
596
596
597 # Add alsa-utils package
597 # Add alsa-utils package
598 if [ "$ENABLE_SOUND" = true ] ; then
598 if [ "$ENABLE_SOUND" = true ] ; then
599 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
599 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
600 fi
600 fi
601
601
602 # Add rng-tools package
602 # Add rng-tools package
603 if [ "$ENABLE_HWRANDOM" = true ] ; then
603 if [ "$ENABLE_HWRANDOM" = true ] ; then
604 APT_INCLUDES="${APT_INCLUDES},rng-tools"
604 APT_INCLUDES="${APT_INCLUDES},rng-tools"
605 fi
605 fi
606
606
607 # Add fbturbo video driver
607 # Add fbturbo video driver
608 if [ "$ENABLE_FBTURBO" = true ] ; then
608 if [ "$ENABLE_FBTURBO" = true ] ; then
609 # Enable xorg package dependencies
609 # Enable xorg package dependencies
610 ENABLE_XORG=true
610 ENABLE_XORG=true
611 fi
611 fi
612
612
613 # Add user defined window manager package
613 # Add user defined window manager package
614 if [ -n "$ENABLE_WM" ] ; then
614 if [ -n "$ENABLE_WM" ] ; then
615 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
615 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
616
616
617 # Enable xorg package dependencies
617 # Enable xorg package dependencies
618 ENABLE_XORG=true
618 ENABLE_XORG=true
619 fi
619 fi
620
620
621 # Add xorg package
621 # Add xorg package
622 if [ "$ENABLE_XORG" = true ] ; then
622 if [ "$ENABLE_XORG" = true ] ; then
623 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
623 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
624 fi
624 fi
625
625
626 # Replace selected packages with smaller clones
626 # Replace selected packages with smaller clones
627 if [ "$ENABLE_REDUCE" = true ] ; then
627 if [ "$ENABLE_REDUCE" = true ] ; then
628 # Add levee package instead of vim-tiny
628 # Add levee package instead of vim-tiny
629 if [ "$REDUCE_VIM" = true ] ; then
629 if [ "$REDUCE_VIM" = true ] ; then
630 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
630 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
631 fi
631 fi
632
632
633 # Add dropbear package instead of openssh-server
633 # Add dropbear package instead of openssh-server
634 if [ "$REDUCE_SSHD" = true ] ; then
634 if [ "$REDUCE_SSHD" = true ] ; then
635 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
635 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
636 fi
636 fi
637 fi
637 fi
638
638
639 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
639 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
640 if [ "$ENABLE_SYSVINIT" = false ] ; then
640 if [ "$ENABLE_SYSVINIT" = false ] ; then
641 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
641 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
642 fi
642 fi
643
643
644 # Configure kernel sources if no KERNELSRC_DIR
644 # Configure kernel sources if no KERNELSRC_DIR
645 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
645 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
646 KERNELSRC_CONFIG=true
646 KERNELSRC_CONFIG=true
647 fi
647 fi
648
648
649 # Configure reduced kernel
649 # Configure reduced kernel
650 if [ "$KERNEL_REDUCE" = true ] ; then
650 if [ "$KERNEL_REDUCE" = true ] ; then
651 KERNELSRC_CONFIG=false
651 KERNELSRC_CONFIG=false
652 fi
652 fi
653
653
654 # Configure qemu compatible kernel
654 # Configure qemu compatible kernel
655 if [ "$ENABLE_QEMU" = true ] ; then
655 if [ "$ENABLE_QEMU" = true ] ; then
656 DTB_FILE=vexpress-v2p-ca15_a7.dtb
656 DTB_FILE=vexpress-v2p-ca15_a7.dtb
657 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
657 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
658 KERNEL_DEFCONFIG="vexpress_defconfig"
658 KERNEL_DEFCONFIG="vexpress_defconfig"
659 if [ "$KERNEL_MENUCONFIG" = false ] ; then
659 if [ "$KERNEL_MENUCONFIG" = false ] ; then
660 KERNEL_OLDDEFCONFIG=true
660 KERNEL_OLDDEFCONFIG=true
661 fi
661 fi
662 fi
662 fi
663
663
664 # Execute bootstrap scripts
664 # Execute bootstrap scripts
665 for SCRIPT in bootstrap.d/*.sh; do
665 for SCRIPT in bootstrap.d/*.sh; do
666 head -n 3 "$SCRIPT"
666 head -n 3 "$SCRIPT"
667 . "$SCRIPT"
667 . "$SCRIPT"
668 done
668 done
669
669
670 ## Execute custom bootstrap scripts
670 ## Execute custom bootstrap scripts
671 if [ -d "custom.d" ] ; then
671 if [ -d "custom.d" ] ; then
672 for SCRIPT in custom.d/*.sh; do
672 for SCRIPT in custom.d/*.sh; do
673 . "$SCRIPT"
673 . "$SCRIPT"
674 done
674 done
675 fi
675 fi
676
676
677 # Execute custom scripts inside the chroot
677 # Execute custom scripts inside the chroot
678 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
678 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
679 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
679 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
680 chroot_exec /bin/bash -x <<'EOF'
680 chroot_exec /bin/bash -x <<'EOF'
681 for SCRIPT in /chroot_scripts/* ; do
681 for SCRIPT in /chroot_scripts/* ; do
682 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
682 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
683 $SCRIPT
683 $SCRIPT
684 fi
684 fi
685 done
685 done
686 EOF
686 EOF
687 rm -rf "${R}/chroot_scripts"
687 rm -rf "${R}/chroot_scripts"
688 fi
688 fi
689
689
690 # Remove c/c++ build environment from the chroot
690 # Remove c/c++ build environment from the chroot
691 chroot_remove_cc
691 chroot_remove_cc
692
692
693 # Generate required machine-id
693 # Generate required machine-id
694 MACHINE_ID=$(dbus-uuidgen)
694 MACHINE_ID=$(dbus-uuidgen)
695 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
695 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
696 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
696 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
697
697
698 # APT Cleanup
698 # APT Cleanup
699 chroot_exec apt-get -y clean
699 chroot_exec apt-get -y clean
700 chroot_exec apt-get -y autoclean
700 chroot_exec apt-get -y autoclean
701 chroot_exec apt-get -y autoremove
701 chroot_exec apt-get -y autoremove
702
702
703 # Unmount mounted filesystems
703 # Unmount mounted filesystems
704 umount -l "${R}/proc"
704 umount -l "${R}/proc"
705 umount -l "${R}/sys"
705 umount -l "${R}/sys"
706
706
707 # Clean up directories
707 # Clean up directories
708 rm -rf "${R}/run/*"
708 rm -rf "${R}/run/*"
709 rm -rf "${R}/tmp/*"
709 rm -rf "${R}/tmp/*"
710
710
711 # Clean up APT proxy settings
711 # Clean up APT proxy settings
712 if [ "$KEEP_APT_PROXY" = false ] ; then
712 if [ "$KEEP_APT_PROXY" = false ] ; then
713 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
713 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
714 fi
714 fi
715
715
716 # Clean up files
716 # Clean up files
717 rm -f "${ETC_DIR}/ssh/ssh_host_*"
717 rm -f "${ETC_DIR}/ssh/ssh_host_*"
718 rm -f "${ETC_DIR}/dropbear/dropbear_*"
718 rm -f "${ETC_DIR}/dropbear/dropbear_*"
719 rm -f "${ETC_DIR}/apt/sources.list.save"
719 rm -f "${ETC_DIR}/apt/sources.list.save"
720 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
720 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
721 rm -f "${ETC_DIR}/*-"
721 rm -f "${ETC_DIR}/*-"
722 rm -f "${ETC_DIR}/resolv.conf"
722 rm -f "${ETC_DIR}/resolv.conf"
723 rm -f "${R}/root/.bash_history"
723 rm -f "${R}/root/.bash_history"
724 rm -f "${R}/var/lib/urandom/random-seed"
724 rm -f "${R}/var/lib/urandom/random-seed"
725 rm -f "${R}/initrd.img"
725 rm -f "${R}/initrd.img"
726 rm -f "${R}/vmlinuz"
726 rm -f "${R}/vmlinuz"
727 rm -f "${R}${QEMU_BINARY}"
727 rm -f "${R}${QEMU_BINARY}"
728
728
729 if [ "$ENABLE_QEMU" = true ] ; then
729 if [ "$ENABLE_QEMU" = true ] ; then
730 # Setup QEMU directory
730 # Setup QEMU directory
731 mkdir "${BASEDIR}/qemu"
731 mkdir "${BASEDIR}/qemu"
732
732
733 # Copy kernel image to QEMU directory
733 # Copy kernel image to QEMU directory
734 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
734 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
735
735
736 # Copy kernel config to QEMU directory
736 # Copy kernel config to QEMU directory
737 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
737 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
738
738
739 # Copy kernel dtbs to QEMU directory
739 # Copy kernel dtbs to QEMU directory
740 for dtb in "${BOOT_DIR}/"*.dtb ; do
740 for dtb in "${BOOT_DIR}/"*.dtb ; do
741 if [ -f "${dtb}" ] ; then
741 if [ -f "${dtb}" ] ; then
742 install_readonly "${dtb}" "${BASEDIR}/qemu/"
742 install_readonly "${dtb}" "${BASEDIR}/qemu/"
743 fi
743 fi
744 done
744 done
745
745
746 # Copy kernel overlays to QEMU directory
746 # Copy kernel overlays to QEMU directory
747 if [ -d "${BOOT_DIR}/overlays" ] ; then
747 if [ -d "${BOOT_DIR}/overlays" ] ; then
748 # Setup overlays dtbs directory
748 # Setup overlays dtbs directory
749 mkdir "${BASEDIR}/qemu/overlays"
749 mkdir "${BASEDIR}/qemu/overlays"
750
750
751 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
751 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
752 if [ -f "${dtb}" ] ; then
752 if [ -f "${dtb}" ] ; then
753 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
753 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
754 fi
754 fi
755 done
755 done
756 fi
756 fi
757
757
758 # Copy u-boot files to QEMU directory
758 # Copy u-boot files to QEMU directory
759 if [ "$ENABLE_UBOOT" = true ] ; then
759 if [ "$ENABLE_UBOOT" = true ] ; then
760 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
760 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
761 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
761 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
762 fi
762 fi
763 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
763 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
764 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
764 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
765 fi
765 fi
766 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
766 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
767 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
767 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
768 fi
768 fi
769 fi
769 fi
770
770
771 # Copy initramfs to QEMU directory
771 # Copy initramfs to QEMU directory
772 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
772 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
773 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
773 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
774 fi
774 fi
775 fi
775 fi
776
776
777 # Calculate size of the chroot directory in KB
777 # Calculate size of the chroot directory in KB
778 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
778 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
779
779
780 # Calculate the amount of needed 512 Byte sectors
780 # Calculate the amount of needed 512 Byte sectors
781 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
781 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
782 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
782 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
783 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
783 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
784
784
785 # The root partition is EXT4
785 # The root partition is EXT4
786 # This means more space than the actual used space of the chroot is used.
786 # This means more space than the actual used space of the chroot is used.
787 # As overhead for journaling and reserved blocks 35% are added.
787 # As overhead for journaling and reserved blocks 35% are added.
788 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
788 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
789
789
790 # Calculate required image size in 512 Byte sectors
790 # Calculate required image size in 512 Byte sectors
791 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
791 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
792
792
793 # Prepare image file
793 # Prepare image file
794 if [ "$ENABLE_SPLITFS" = true ] ; then
794 if [ "$ENABLE_SPLITFS" = true ] ; then
795 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
795 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
796 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
796 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
797 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
797 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
798 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
798 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
799
799
800 # Write firmware/boot partition tables
800 # Write firmware/boot partition tables
801 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
801 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
802 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
802 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
803 EOM
803 EOM
804
804
805 # Write root partition table
805 # Write root partition table
806 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
806 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
807 ${TABLE_SECTORS},${ROOT_SECTORS},83
807 ${TABLE_SECTORS},${ROOT_SECTORS},83
808 EOM
808 EOM
809
809
810 # Setup temporary loop devices
810 # Setup temporary loop devices
811 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
811 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
812 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
812 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
813 else # ENABLE_SPLITFS=false
813 else # ENABLE_SPLITFS=false
814 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
814 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
815 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
815 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
816
816
817 # Write partition table
817 # Write partition table
818 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
818 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
819 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
819 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
820 ${ROOT_OFFSET},${ROOT_SECTORS},83
820 ${ROOT_OFFSET},${ROOT_SECTORS},83
821 EOM
821 EOM
822
822
823 # Setup temporary loop devices
823 # Setup temporary loop devices
824 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
824 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
825 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
825 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
826 fi
826 fi
827
827
828 if [ "$ENABLE_CRYPTFS" = true ] ; then
828 if [ "$ENABLE_CRYPTFS" = true ] ; then
829 # Create dummy ext4 fs
829 # Create dummy ext4 fs
830 mkfs.ext4 "$ROOT_LOOP"
830 mkfs.ext4 "$ROOT_LOOP"
831
831
832 # Setup password keyfile
832 # Setup password keyfile
833 touch .password
833 touch .password
834 chmod 600 .password
834 chmod 600 .password
835 echo -n ${CRYPTFS_PASSWORD} > .password
835 echo -n ${CRYPTFS_PASSWORD} > .password
836
836
837 # Initialize encrypted partition
837 # Initialize encrypted partition
838 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
838 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
839
839
840 # Open encrypted partition and setup mapping
840 # Open encrypted partition and setup mapping
841 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
841 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
842
842
843 # Secure delete password keyfile
843 # Secure delete password keyfile
844 shred -zu .password
844 shred -zu .password
845
845
846 # Update temporary loop device
846 # Update temporary loop device
847 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
847 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
848
848
849 # Wipe encrypted partition (encryption cipher is used for randomness)
849 # Wipe encrypted partition (encryption cipher is used for randomness)
850 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
850 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
851 fi
851 fi
852
852
853 # Build filesystems
853 # Build filesystems
854 mkfs.vfat "$FRMW_LOOP"
854 mkfs.vfat "$FRMW_LOOP"
855 mkfs.ext4 "$ROOT_LOOP"
855 mkfs.ext4 "$ROOT_LOOP"
856
856
857 # Mount the temporary loop devices
857 # Mount the temporary loop devices
858 mkdir -p "$BUILDDIR/mount"
858 mkdir -p "$BUILDDIR/mount"
859 mount "$ROOT_LOOP" "$BUILDDIR/mount"
859 mount "$ROOT_LOOP" "$BUILDDIR/mount"
860
860
861 mkdir -p "$BUILDDIR/mount/boot/firmware"
861 mkdir -p "$BUILDDIR/mount/boot/firmware"
862 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
862 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
863
863
864 # Copy all files from the chroot to the loop device mount point directory
864 # Copy all files from the chroot to the loop device mount point directory
865 rsync -a "${R}/" "$BUILDDIR/mount/"
865 rsync -a "${R}/" "$BUILDDIR/mount/"
866
866
867 # Unmount all temporary loop devices and mount points
867 # Unmount all temporary loop devices and mount points
868 cleanup
868 cleanup
869
869
870 # Create block map file(s) of image(s)
870 # Create block map file(s) of image(s)
871 if [ "$ENABLE_SPLITFS" = true ] ; then
871 if [ "$ENABLE_SPLITFS" = true ] ; then
872 # Create block map files for "bmaptool"
872 # Create block map files for "bmaptool"
873 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
873 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
874 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
874 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
875
875
876 # Image was successfully created
876 # Image was successfully created
877 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
877 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
878 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
878 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
879 else
879 else
880 # Create block map file for "bmaptool"
880 # Create block map file for "bmaptool"
881 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
881 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
882
882
883 # Image was successfully created
883 # Image was successfully created
884 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
884 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
885
885
886 # Create qemu qcow2 image
886 # Create qemu qcow2 image
887 if [ "$ENABLE_QEMU" = true ] ; then
887 if [ "$ENABLE_QEMU" = true ] ; then
888 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
888 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
889 QEMU_SIZE=16G
889 QEMU_SIZE=16G
890
890
891 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
891 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
892 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
892 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
893
893
894 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
894 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
895 fi
895 fi
896 fi
896 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant